BoE/BoE.WebSite/Controllers/API/GameController.cs
using BoE.Lib;
using BoE.Models;
using BoE.Contexts;
using BoE.Business;
using BoE.WebSite.Filters;
using BoE.Formatters;
using BoE.WebSite.Business;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Configuration;
using BoE.WebSite.Models;


namespace BoE.WebSite.Controllers
{
    [AllowAnonymous]
    [WSEModelError]
    [WSEException]
    public class GameController : ApiController
    {
        BoEContext db = new BoEContext();

        [HttpGet]
        [RequireToken]
        public HttpResponseMessage GetChar(int reqId, int id, string name, string token, int withStats = 0)
        {
            User user = db.Users.FirstOrDefault(u => u.UniqueId == id);

            if (user == null)
            {
                if (db.Characters.Any(c => c.Name == name))
                    return this.CreateWSEResponse(HttpStatusCode.OK, reqId, new 
                    { 
                        Status = (int)GetCharStatus.NameTaken, 
                        Id = id 
                    });
                else
                    user = UserB.CreateUser(id, name, db);
            }
            else if (user.Character.Name != name)
            {
                return this.CreateWSEResponse(HttpStatusCode.OK, reqId, new 
                { 
                    Status = (int)GetCharStatus.WrongName, 
                    Id = id, 
                    Name = user.Character.Name 
                });
            }
            if (user.State == UserState.New)
            {
                var code = user.Codes.Select(c => new { Type=c.Type, Value=c.Value }).FirstOrDefault(c => c.Type == CodeType.Register);
                if (withStats == 1)
                {
                    return this.CreateWSEResponse(HttpStatusCode.OK, reqId, new
                    {
                        Status = (int)GetCharStatus.NewUser,
                        Code = code.Value,
                        UniqueId = id,
                        Character = user.Character
                    });
                }
                else
                {
                    return this.CreateWSEResponse(HttpStatusCode.OK, reqId, new
                    {
                        Status = (int)GetCharStatus.NewUser,
                        Code = code.Value,
                        UniqueId = id
                    });
                }
            }

            GameServer gameServer = db.Tokens.First(t => t.Value == token).GameServer;
            bool isAdmin = db.CharacterGameRoles.Select(cgr => new 
            {
                CharacterId=cgr.CharacterId,
                GameServerId=cgr.GameServerId,
                GameRoleType = cgr.GameRoleType
            }).Any(cgr => cgr.CharacterId==user.UserId && cgr.GameServerId == gameServer.GameServerId && cgr.GameRoleType == CharacterGameRoleType.Admin);

            int status = isAdmin ? (int)GetCharStatus.Admin : (int)GetCharStatus.Ok;
            status = user.Character.IsBanned() ? (int)GetCharStatus.Banned : status;

            if (withStats == 1)
            {
                return this.CreateWSEResponse(HttpStatusCode.OK, reqId, new
                {
                    Status = status,
                    UniqueId = id,
                    Character = user.Character
                });
            }
            else
            {
                return this.CreateWSEResponse(HttpStatusCode.OK, reqId, new
                {
                    Status = status,
                    UniqueId = id
                });
            }
        }

        [HttpGet]
        [RequireToken]
        public HttpResponseMessage DoTick(int reqId, string ids, string token)
        {
            GameServer gameServer = db.Tokens.First(t => t.Value == token).GameServer;
            int tickCD = int.Parse(WebConfigurationManager.AppSettings["TickCD"]);

            if (gameServer.LastTick.HasValue && DateTime.Now < gameServer.LastTick.Value.AddSeconds(tickCD))
                return this.CreateWSEResponse(HttpStatusCode.Conflict, reqId);

            int gold = int.Parse(WebConfigurationManager.AppSettings["GoldTick"]);
            int exp = int.Parse(WebConfigurationManager.AppSettings["ExpTick"]);

            IEnumerable<UserScore> userScores = GetUserScoresFromString(ids, db);
            foreach (UserScore userScore in userScores)
            {
                if (userScore.Tick == 0)
                    continue;
                //Hotfix check for weird kill/death values
                if (GameB.KDIsBullShit(userScore.Kills, userScore.Deaths, userScore.Score))
                {
                    userScore.Kills = 0;
                    userScore.Deaths = 0;
                }

                if (userScore.User.Character.LastTick.HasValue && DateTime.Now < userScore.User.Character.LastTick.Value.AddSeconds(tickCD))
                    continue;

                Character character = userScore.User.Character;
                int goldWon = GameB.GetTickGold(gold, userScore.Score, character.Generation, character.WinARow);
                int ExperienceWon = GameB.GetTickExp(exp, userScore.Score, character.Generation, character.WinARow);

                character.Experience += ExperienceWon;
                character.Gold += goldWon;
                character.Kills += userScore.Kills;
                character.Deaths += userScore.Deaths;
                character.LastTick = DateTime.Now;
                character.TicksSinceLastUpkeep++;

                db.UserActions.Add(new UserTick()
                {
                    UserId = userScore.User.UserId,
                    Score = userScore.Score,
                    WinARow = character.WinARow,
                    Kills = userScore.Kills,
                    Deaths = userScore.Deaths,
                    AddressIp = this.GetClientIp(),
                    GameServerId = gameServer.GameServerId,
                    Gold = goldWon,
                    Experience = ExperienceWon,
                    Tick = userScore.Tick
                });
            }
            gameServer.CharList = ids.Replace(" ", "").Split(new string[] { "],[" }, StringSplitOptions.None)
                .Select(s => s.Replace("[", "").Replace("]", "").Split(',').First()).Aggregate((a,b) => a + "," + b);
            gameServer.LastTick = DateTime.Now;
            db.SaveChanges();

            return this.CreateWSEResponse(HttpStatusCode.OK, reqId);
        }

        [HttpGet]
        [RequireToken]
        public HttpResponseMessage Upkeep(int reqId, string usages, string token)
        {
            GameServer gameServer = db.Tokens.First(t => t.Value == token).GameServer;
            IEnumerable<UserUsagesModel> userUsages = GetUserUpKeepFromString(usages, db);
            foreach (UserUsagesModel userUsage in userUsages)
            {
                Character character = userUsage.User.Character;
                int tickCount = character.TicksSinceLastUpkeep;
                List<int> gameIds = userUsage.Usages.Select(u => u.Key).ToList();
                IEnumerable<int> charItems = character.Inventories.Select(i => i.ItemId);
                var items = db.Items.Select(i => new UpKeepCalculationModel()
                {  
                    ItemId=i.ItemId,
                    HitPoint= i.HitPoint,
                    Type=i.Type,
                    GameId=i.GameId,
                    ItemValue=i.Value
                }).Where(i => gameIds.Contains(i.GameId));

                int total = 0;
                List<UserUpKeepUsage> userUpUsages = new List<UserUpKeepUsage>();
                foreach (KeyValuePair<int, int> usgs in userUsage.Usages)
                {
                    UpKeepCalculationModel itemUsed = items.FirstOrDefault(i => i.GameId == usgs.Key);
                    if (!charItems.Contains(itemUsed.ItemId))
                        continue; //Sebastian the noob

                    if (itemUsed != null)
                    {
                        if (itemUsed.Type == ItemType.Arrow || itemUsed.Type == ItemType.Bullet || itemUsed.Type == ItemType.Throwing || itemUsed.Type == ItemType.Bolt)
                            itemUsed.Ammo = db.Items.OfType<Weapon>().Select(w => new { ItemId = w.ItemId, Ammo = w.Ammo }).First(w => w.ItemId == itemUsed.ItemId).Ammo;

                        int upkeep = GameB.GetUpkeepValue(itemUsed.HitPoint, itemUsed.Ammo,
                            itemUsed.ItemValue, usgs.Value, itemUsed.Type, userUsage.RespawnCount, tickCount);
                        if (userUsage.User.Character.Gold > upkeep)
                        {
                            userUsage.User.Character.Gold -= upkeep;
                            total += upkeep;
                        }
                        else
                            character.Inventories.First(iv => iv.RepairPrice == null && iv.ItemId == itemUsed.ItemId).RepairPrice = upkeep;
                        userUpUsages.Add(new UserUpKeepUsage() { 
                            ItemId=itemUsed.ItemId,
                            Usage = usgs.Value
                        });
                    }
                }
                db.UserActions.Add(new UserUpKeep() { 
                    AddressIp = this.GetClientIp(),
                    GameServerId = gameServer.GameServerId,
                    Golds = total,
                    UserId=userUsage.User.UserId,
                    UserUpKeepUsages = userUpUsages,
                    RoundResult = userUsage.RoundResult,
                    RespawnCount = userUsage.RespawnCount,
                    TickCount = tickCount
                });

                character.TicksSinceLastUpkeep = 0;
                if (userUsage.RoundResult == RoundResult.Won)
                {
                    character.Wins++;
                    character.WinARow++;
                }
                else
                {

BoE/BoE.WebSite/Areas/Admin/Views/Shared/_CharactersTable.cshtml
@model IEnumerable<BoE.WebSite.Areas.Admin.Models.CharacterModel>

<table class="table-rounded bordered">
    <thead>
        <tr>
            <th>@Html.DisplayNameFor(m => m.Name)</th>
            <th>@Html.DisplayNameFor(m => m.Level)</th>
            <th>@Html.DisplayNameFor(m => m.Generation)</th>
            <th>@Html.DisplayNameFor(m => m.Gold)</th>
            <th>@Html.DisplayNameFor(m => m.Experience)</th>
            <th>@Html.DisplayNameFor(m => m.LastSeen)</th>
            <th>@Html.DisplayNameFor(m => m.CreationDate)</th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var ch in Model)
        {
            <tr>
                <td>@Html.DisplayFor(m => ch.Name)</td>
                <td>@Html.DisplayFor(m => ch.Level)</td>
                <td>@Html.DisplayFor(m => ch.Generation)</td>
                <td>@Html.DisplayFor(m => ch.Gold)</td>
                <td>@Html.DisplayFor(m => ch.Experience)</td>
                <td>@(ch.LastSeen.HasValue ? ch.LastSeen.Value.ToString("dd/MM/yy") : "")</td>
                <td>@ch.CreationDate.ToString("dd/MM/yy")</td>
                <td>
                    @Html.ActionLink("details", "CharacterDetails", new { characterId=ch.CharacterId }) <span> | </span>
                    @Html.ActionLink("ban", "BanCharacter", new { characterId=ch.CharacterId }) <span> | </span>
                    @Html.ActionLink("give gold/xp", "GiveGoldXp", new { characterId=ch.CharacterId }) <span> | </span>
                    @Html.ActionLink("manage game role", "ManageGameRole", new { characterId=ch.CharacterId })
                </td>
            </tr>
        }
    </tbody>
</table>

BoE/BoE.WebSite/Areas/Admin/Views/Shared/_Layout.cshtml
@inherits System.Web.Mvc.WebViewPage
@using System.Web.Mvc
@using System.Web.Mvc.Html
<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <title>BoE Administration</title>
    @Styles.Render("~/Content/admin")
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/admin")
    @if (TempData["alert"] != null){
        <script type="text/javascript">
            alert("@TempData["alert"]");
        </script>
    }
</head>
<body>
    <header>
        <ul id="admin-menu" class="inline-block">
            <li>@Html.ActionLink("Home", "Index", "Home")</li>
            @if(BoE.WebSite.Business.BoESecurity.IsAuthenticated) 
            {
                if(Roles.IsUserInRole(BoE.Contexts.RolesFactory.Moderator)) 
                {
                    <li>@Html.ActionLink("User management", "Index", "User")</li>
                }
                if(Roles.IsUserInRole(BoE.Contexts.RolesFactory.Admin)) 
                {
                    <li>@Html.ActionLink("Game management", "Index", "Game")</li>
                    <li>@Html.ActionLink("Item management", "Index", "Item")</li>
                    <li>@Html.ActionLink("Statistics", "Index", "Stats")</li>
                }
            }
        </ul>
    </header>
    <div>
        @RenderBody()
    </div>
</body>
</html>

BoE/BoE.WebSite/Areas/Admin/Views/Shared/_Report.cshtml
@model string[]
@{
    ViewBag.Title = "Admin | Report";
}

<h2>Report</h2>

@foreach (string text in Model)
{
    <p>
        @text
    </p>
}

@if (ViewBag.GoBack != null)
{
    <p>
        @Html.ActionLink("Go back", (string)ViewBag.GoBack)
    </p>
}